﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Algoritm : Form
    {
        /// <summary>
        /// Вычисляет f в зависимости от выбраного метода 
        /// </summary>
        /// <param name="x">Число вводит пользователь</param>
        /// <param name="y">Число вводит пользователь</param>
        /// <param name="e">Число вводит пользователь</param>
        /// <returns>Возвращаеться число f</returns>
        public double CalculateF(double x, double y, double e)
        {
            double f = 0;
            if (rbSH.Checked == true)
                f = (e * x) - e - (Math.Pow(x, 2));
            if (rbX.Checked == true)
                f = Math.Pow(x, 2);
            if (rbE.Checked == true)
                f = Math.Pow(e, x);
            return f;
        }
        /// <summary>
        /// Метод который вычисляет математическое выражение
        /// </summary>
        public void Resh() 
        {
            tbOutput.Clear();
            double x = 0;
            double y = 0;
            double e = 0;
            //Обработка ошибки
            try
            {
                x = Convert.ToDouble(tbInputX.Text);
            } catch
            {
                tbInputX.Text = "Ошибка";
            }
            try
            {
                y = Convert.ToDouble(tbInputY.Text);
            }
            catch
            {
                tbInputY.Text = "Ошибка";
            }
            try
            {
                e = Convert.ToDouble(tbInputE.Text);
            }
            catch
            {
                tbInputE.Text = "Ошибка";
            }
            double f = CalculateF(x, y, e);
            double temp = x - y;
            double result = 0;
            if (temp == 0)
                result = Math.Sin(f * x) + Math.Cos(f * y);
            if (temp > 0)
                result = Math.Tan(f*(x + y));
            if (temp < 0)
                result = Math.Pow(Math.Sin(f*x), 2) + Math.Pow(Math.Cos(f*y),2);
            result = Math.Round(result, 3);
            OutputAnswer(result);
        }
        /// <summary>
        /// Метод выводит информацию в tbOutput 
        /// </summary>
        public void OutputAnswer(double result)
        {
            tbOutput.Text += "Результат работы программы" + Environment.NewLine;
            tbOutput.Text += "При X = " + tbInputX.Text + Environment.NewLine;
            tbOutput.Text += "При Y = " + tbInputY.Text + Environment.NewLine;
            tbOutput.Text += "C = " + result;
        }

        public Algoritm()
        {
            InitializeComponent();
        }
        /// <summary>
        /// Обработка нажатия на кнопку
        /// </summary>
        private void btnResh_Click(object sender, EventArgs e)
        {
            Resh();
        }
    }
}
